#ifndef __PI_MUTEX_C_H
#define __PI_MUTEX_C_H
#include <linux/pimutex.h>

enum pimutex_chainwalk {
	PI_MUTEX_MIN_CHAINWALK,
	PI_MUTEX_FULL_CHAINWALK,
};

struct rt_mutex_waiter
{
    struct rb_node tree_entry;
    struct rb_node pi_tree_entry;
    struct task_struct *task;
    struct pi_mutex *lock;
    int prio;
    u64 deadline;
};

static inline int pi_mutex_has_waiters(struct pi_mutex *lock)
{
    return false;
}

static inline struct rt_mutex_waiter *
pi_mutex_top_waiter(struct pi_mutex *lock)
{
    return NULL;
}

static inline int task_has_pi_waiters(struct task_struct *p)
{
    return false;
}

static inline struct rt_mutex_waiter *
task_top_pi_waiter(struct task_struct *p)
{
    return NULL;
}

static inline struct task_struct *pi_mutex_owner(struct pi_mutex *lock)
{
	unsigned long owner = (unsigned long) READ_ONCE(lock->owner);

	return (struct task_struct *) (owner & ~PI_MUTEX_HAS_WAITERS);
}

static inline void pi_mutex_print_deadlock(struct rt_mutex_waiter *w)
{
	WARN(1, "pi_mutex deadlock detected\n");
}

static inline bool debug_pi_mutex_detect_deadlock(struct rt_mutex_waiter *w,
						  enum pimutex_chainwalk walk)
{
	return walk == PI_MUTEX_FULL_CHAINWALK;
}

#endif // !__PI_MUTEX_H
