#ifndef __PI_RWLOCK_C_H
#define __PI_RWLOCK_C_H
#include <linux/pirwlock.h>

enum pirwlock_chainwalk {
	PI_RWLOCK_MIN_CHAINWALK,
	PI_RWLOCK_FULL_CHAINWALK,
};

struct rt_mutex_waiter
{
    struct rb_node tree_entry;
    struct rb_node pi_tree_entry;
    struct task_struct *task;
    struct pi_rwlock *lock;
    int prio;
    u64 deadline;
};

static inline int pi_rwlock_has_waiters(struct pi_rwlock *lock)
{
    return false;
}

static inline struct rt_mutex_waiter *
pi_rwlock_top_waiter(struct pi_rwlock *lock)
{
    return NULL;
}

static inline int task_has_pi_waiters(struct task_struct *p)
{
    return false;
}

static inline struct rt_mutex_waiter *
task_top_pi_waiter(struct task_struct *p)
{
    return NULL;
}

static inline struct task_struct *pi_rwlock_owner(struct pi_rwlock *lock)
{
	unsigned long owner = (unsigned long) READ_ONCE(lock->owner);

	return (struct task_struct *) (owner & ~PI_LOCK_HAS_WAITERS);
}

static inline void pi_rwlock_print_deadlock(struct rt_mutex_waiter *w)
{
	WARN(1, "pi_write_lock deadlock detected\n");
}

static inline bool debug_pi_rwlock_detect_deadlock(struct rt_mutex_waiter *w,
						  enum pirwlock_chainwalk walk)
{
	return walk == PI_RWLOCK_FULL_CHAINWALK;
}

#endif // !__PI_RWLOCK_C_H
