#ifndef __PI_RWSEM_C_H
#define __PI_RWSEM_C_H
#include <linux/pirwsem.h>

enum pirwsem_chainwalk {
	PI_RWSEM_MIN_CHAINWALK,
	PI_RWSEM_FULL_CHAINWALK,
};

struct rt_mutex_waiter
{
    struct rb_node tree_entry;
    struct rb_node pi_tree_entry;
    struct task_struct *task;
    struct pi_rwsem *lock;
    int prio;
    u64 deadline;
};

static inline int pi_rwsem_has_waiters(struct pi_rwsem *lock)
{
    return false;
}

static inline struct rt_mutex_waiter *
pi_rwsem_top_waiter(struct pi_rwsem *lock)
{
    return NULL;
}

static inline int task_has_pi_waiters(struct task_struct *p)
{
    return false;
}

static inline struct rt_mutex_waiter *
task_top_pi_waiter(struct task_struct *p)
{
    return NULL;
}

static inline struct task_struct *pi_rwsem_owner(struct pi_rwsem *lock)
{
	unsigned long owner = (unsigned long) READ_ONCE(lock->owner);

	return (struct task_struct *) (owner & ~PI_RWSEM_HAS_WAITERS);
}

static inline void pi_rwsem_print_deadlock(struct rt_mutex_waiter *w)
{
	WARN(1, "pi_write_sem deadlock detected\n");
}

static inline bool debug_pi_rwsem_detect_deadlock(struct rt_mutex_waiter *w,
						  enum pirwsem_chainwalk walk)
{
	return walk == PI_RWSEM_FULL_CHAINWALK;
}

#endif // !__PI_RWSEM_C_H
