#ifndef __PI_MUTEX_H
#define __PI_MUTEX_H
#include <linux/linkage.h>
#include <linux/rbtree.h>
#include <linux/spinlock_types.h>
#include <linux/sched/wake_q.h>

extern int max_lock_depth; /* for sysctl */
#define PI_MUTEX_HAS_WAITERS 1UL

struct pi_mutex
{
    raw_spinlock_t wait_lock;
    struct rb_root_cached waiters;
    struct task_struct *owner;
};

struct rt_mutex_waiter;
struct hrtimer_sleeper;

# define pi_mutex_init(pi_mutex)			__pi_mutex_init(pi_mutex, NULL, NULL)
extern void __pi_mutex_init(struct pi_mutex *lock, const char *name, struct lock_class_key *key);

extern void pi_mutex_lock(struct pi_mutex *lock);

extern void pi_mutex_unlock(struct pi_mutex *lock);

#endif // !__PI_MUTEX_H
