#ifndef __PI_RWLOCK_H
#define __PI_RWLOCK_H
#include <linux/linkage.h>
#include <linux/rbtree.h>
#include <linux/spinlock_types.h>
#include <linux/sched/wake_q.h>

extern int max_lock_depth; /* for sysctl */
#define PI_RWLOCK_HAS_WAITERS 1UL

struct pi_rwlock
{
    atomic_long_t count;
	struct list_head wait_list;
    raw_spinlock_t wait_lock;
    struct rb_root_cached waiters;
    struct task_struct *owner;
};

struct rt_mutex_waiter;
struct hrtimer_sleeper;

# define pi_rwlock_init(pi_rwlock)			__pi_rwlock_init(pi_rwlock, NULL, NULL)
extern void __pi_rwlock_init(struct pi_rwlock *lock, const char *name, struct lock_class_key *key);

extern void pi_rwlock_lock(struct pi_rwlock *lock);

extern void pi_rwlock_unlock(struct pi_rwlock *lock);

#endif // !__PI_RWLOCK_H
