#ifndef __PI_RWSEM_H
#define __PI_RWSEM_H
#include <linux/linkage.h>
#include <linux/rbtree.h>
#include <linux/spinlock_types.h>
#include <linux/sched/wake_q.h>

extern int max_lock_depth; /* for sysctl */
#define PI_RWSEM_HAS_WAITERS 1UL

struct pi_rwsem
{
    atomic_long_t count;
	struct list_head wait_list;
    raw_spinlock_t wait_lock;
    struct rb_root_cached waiters;
    struct task_struct *owner;
};

struct rt_mutex_waiter;
struct hrtimer_sleeper;

# define pi_rwsem_init(pi_rwsem)			__pi_rwsem_init(pi_rwsem, NULL, NULL)
extern void __pi_rwsem_init(struct pi_rwsem *lock, const char *name, struct lock_class_key *key);

extern void pi_rwsem_lock(struct pi_rwsem *lock);

extern void pi_rwsem_unlock(struct pi_rwsem *lock);

#endif // !__PI_RWSEM_H
